//date 2015/09/24 yokomizo
//ピン番号マクロ定義
#define clk_pin 0
#define lat_pin 1
#define r1_pin 2
#define g1_pin 3
#define b1_pin 4
#define r2_pin 5
#define g2_pin 6
#define b2_pin 7
#define oeb_pin 8
#define a_pin 9
#define b_pin 10
#define c_pin 11
void setup() { 
  //出力モード指定
  pinMode(clk_pin, OUTPUT);     
  pinMode(lat_pin, OUTPUT);     
  pinMode(r1_pin, OUTPUT);      
  pinMode(g1_pin, OUTPUT);      
  pinMode(b1_pin, OUTPUT);        
  pinMode(r2_pin, OUTPUT);      
  pinMode(g2_pin, OUTPUT);      
  pinMode(b2_pin, OUTPUT);     
  pinMode(oeb_pin, OUTPUT);     
  pinMode(a_pin, OUTPUT);     
  pinMode(b_pin, OUTPUT);     
  pinMode(c_pin, OUTPUT);   
} 

void loop() { 
  int clk_cnt;
  //ライン0選択
  digitalWrite(a_pin, LOW);
  digitalWrite(b_pin, LOW);
  digitalWrite(c_pin, LOW);
  digitalWrite(r1_pin, LOW);
  digitalWrite(g1_pin, LOW);
  digitalWrite(b1_pin, LOW);
  digitalWrite(r2_pin, LOW);
  digitalWrite(g2_pin, LOW);
  digitalWrite(b2_pin, LOW);
  //シリアルデータ
  for(clk_cnt=0;clk_cnt<32;clk_cnt++){
      digitalWrite(clk_pin, LOW);
      //1クロック目でr1を１にする
      if(clk_cnt==0)
         digitalWrite(r1_pin, HIGH);
      else
         digitalWrite(r1_pin, LOW);
      //32CLK目でロード
      if(clk_cnt==31)
         digitalWrite(lat_pin, HIGH);
      else
      //1CLK目でラッチ
         digitalWrite(lat_pin, LOW);
      //2CLK目で出力イネーブル
      if(clk_cnt==1)
         digitalWrite(oeb_pin, LOW);
      //31CLK目で出力ディセーブル
      else if(clk_cnt==30)
         digitalWrite(oeb_pin, HIGH);
      //クロックの立ち上がり
      digitalWrite(clk_pin, HIGH);
  }
}
